"use strict";
// Copyright (c) satotake
// Distributed under the terms of the Modified BSD License.
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SandDanceView = exports.SandDanceModel = void 0;
const base_1 = require("@jupyter-widgets/base");
const version_1 = require("./version");
const deck = __importStar(require("@deck.gl/core"));
const layers = __importStar(require("@deck.gl/layers"));
const luma = __importStar(require("luma.gl"));
const fabric = __importStar(require("office-ui-fabric-react"));
const vega = __importStar(require("vega"));
const sanddance_explorer_1 = require("@msrvida/sanddance-explorer");
const react_dom_1 = __importDefault(require("react-dom"));
const react_1 = __importDefault(require("react"));
require("../css/widget.css");
// TODO
sanddance_explorer_1.use(fabric, vega, deck, layers, luma);
fabric.initializeIcons();
let SandDanceModel = /** @class */ (() => {
    class SandDanceModel extends base_1.DOMWidgetModel {
        defaults() {
            return Object.assign(Object.assign({}, super.defaults()), { _model_name: SandDanceModel.model_name, _model_module: SandDanceModel.model_module, _model_module_version: SandDanceModel.model_module_version, _view_name: SandDanceModel.view_name, _view_module: SandDanceModel.view_module, _view_module_version: SandDanceModel.view_module_version, value: '[]', width: '100%', heigth: '60vh', snapshots: [] });
        }
    }
    SandDanceModel.serializers = Object.assign({}, base_1.DOMWidgetModel.serializers);
    SandDanceModel.model_name = 'SandDanceModel';
    SandDanceModel.model_module = version_1.MODULE_NAME;
    SandDanceModel.model_module_version = version_1.MODULE_VERSION;
    SandDanceModel.view_name = 'SandDanceView';
    SandDanceModel.view_module = version_1.MODULE_NAME;
    SandDanceModel.view_module_version = version_1.MODULE_VERSION;
    return SandDanceModel;
})();
exports.SandDanceModel = SandDanceModel;
class SandDanceView extends base_1.DOMWidgetView {
    render() {
        const explorerProps = {
            logoClickUrl: 'https://microsoft.github.io/SandDance/',
            compactUI: true,
            mounted: (explorer) => {
                this.explorer = explorer;
                this.model.on('change:value', this.value_changed, this);
                setTimeout(() => {
                    this.value_changed();
                }, 1);
            },
            // TODO
            ref: (ref) => {
                // restore previoous snapshot states
                ref.state.snapshots = this.model.get('snapshots');
                this.intervalID = this.autosaveSnapshots(ref);
            },
            key: 'explorer-key'
        };
        this.wrapper = react_1.default.createElement('div', {
            style: {
                width: this.model.get('width'),
                height: this.model.get('height'),
            }
        }, [react_1.default.createElement(sanddance_explorer_1.Explorer, explorerProps)]);
        react_dom_1.default.render(this.wrapper, this.el);
        this.model.on('change:width', this.size_changed, this);
        this.model.on('change:height', this.size_changed, this);
    }
    // TODO
    autosaveSnapshots(ref) {
        return setInterval(() => {
            this.model.set('snapshots', ref.state.snapshots);
            this.model.save_changes();
        }, 1000 * 10);
    }
    size_changed() {
        if (!this.wrapper) {
            return;
        }
        const style = {
            width: this.model.get('width'),
            height: this.model.get('height'),
        };
        this.wrapper.props.style = style;
    }
    value_changed() {
        if (!this.explorer) {
            return;
        }
        this.explorer.load(JSON.parse(this.model.get('value')));
    }
    remove() {
        if (this.intervalID) {
            clearInterval(this.intervalID);
        }
        super.remove();
    }
}
exports.SandDanceView = SandDanceView;
//# sourceMappingURL=widget.js.map